//------------------------------------------------------------------------------
//---------------------------    ---------------------------
//-------------     STM32F4Diuscovery ----------------
//-------------------    ----------------------
//----------------------------- yagov@promelec.ru ------------------------------
//---------------------------- support@promelec.ru -----------------------------
//------------------------------------------------------------------------------
//---------------------------   12 --------------------------
//-----------       RTC -------------------
//------------------------------------------------------------------------------

#include "stm32f4xx.h"

//------------------------------------------------------------------------------
//   
u32 Delay;
RTC_TimeTypeDef  RTC_TimeStruct;
//  
int main();
void Pause();
void EXTILine17_Config(void);
void RTC_Configuration(void);

//------------------------------------------------------------------------------

int main()
{
  // ,     
  GPIO_InitTypeDef GPIO_InitStructure;

//       D    
//  ,  "1"   D   
//    D,    : 12, 13, 14, 15


//     
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
  
//   ,    
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;

//    
//   
//   100 ( )
//  -
//     
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOD, &GPIO_InitStructure);

  EXTILine17_Config();
  
  Delay=1000000;
  
  GPIO_Write(GPIOD, 32768);
  Pause();
  GPIO_Write(GPIOD, 16384);
  Pause();
  GPIO_Write(GPIOD, 8192);
  Pause();
  GPIO_Write(GPIOD, 4096);  
  Pause();

RTC_Configuration();

//  Delay=100000;
while(1)
{
  GPIO_Write(GPIOD, 32768);
  Pause();
  GPIO_Write(GPIOD, 16384);
  Pause();
  GPIO_Write(GPIOD, 8192);
  Pause();
  GPIO_Write(GPIOD, 4096);  
  Pause();
}
}

void Pause()
{
  // ,    
  //       -     8
  //   : 8  - 1  ,  1     
  //     1.
  u32 I;
  for(I=0;I<Delay;I++);
}


void EXTILine17_Config(void)
{
  //   A0,        
  //         
  //       3.3
  
  EXTI_InitTypeDef   EXTI_InitStructure;
  GPIO_InitTypeDef   GPIO_InitStructure;
  NVIC_InitTypeDef   NVIC_InitStructure;

  //  
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
  
 
  //  
  //   
  //   
  //  - 0
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  //   PA0    
//  SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOA, EXTI_PinSource0);

  //        17 ( RTC Alarm ....  -)
  // -   
  // -    (/)
  // -  
  EXTI_InitStructure.EXTI_Line = EXTI_Line17;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;  
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  //   
  // -  
  // -  
  // -  
  NVIC_InitStructure.NVIC_IRQChannel = RTC_Alarm_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

}


void RTC_Configuration(void)
{
RTC_AlarmTypeDef RTC_AlarmStructure;
RTC_InitTypeDef RTC_InitStructure;

//  
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);

//    BKP    
  PWR_BackupAccessCmd(ENABLE);
  PWR_ClearFlag(PWR_FLAG_WU);
  RCC_BackupResetCmd(ENABLE);
  RCC_BackupResetCmd(DISABLE);

//  LSI
RCC_LSICmd(ENABLE);

//   LSI
while(RCC_GetFlagStatus(RCC_FLAG_LSIRDY) == RESET)
{
}

//  LSI     RTC
RCC_RTCCLKConfig(RCC_RTCCLKSource_LSI);

//  RTC
RCC_RTCCLKCmd(ENABLE);
//  (  ...   -  )
RTC_WaitForSynchro();

//  
RTC_InitStructure.RTC_AsynchPrediv = 0x7F;
RTC_InitStructure.RTC_SynchPrediv  = 0xFF;
RTC_InitStructure.RTC_HourFormat   = RTC_HourFormat_24;
RTC_Init(&RTC_InitStructure);

//  
RTC_TimeStruct.RTC_H12     = RTC_H12_AM;
RTC_TimeStruct.RTC_Hours   = 0x00;
RTC_TimeStruct.RTC_Minutes = 0x00;
RTC_TimeStruct.RTC_Seconds = 0x00;  
RTC_SetTime(RTC_Format_BCD, &RTC_TimeStruct);

//   
RTC_ClearFlag(RTC_FLAG_ALRAF);

//  " "
RTC_AlarmCmd(RTC_Alarm_A, DISABLE);

RTC_GetTime(RTC_Format_BIN, &RTC_TimeStruct);

//      + 5 
RTC_AlarmStructure.RTC_AlarmTime.RTC_H12     = RTC_TimeStruct.RTC_H12;
RTC_AlarmStructure.RTC_AlarmTime.RTC_Hours   = RTC_TimeStruct.RTC_Hours;
RTC_AlarmStructure.RTC_AlarmTime.RTC_Minutes = RTC_TimeStruct.RTC_Minutes;
RTC_AlarmStructure.RTC_AlarmTime.RTC_Seconds = (RTC_TimeStruct.RTC_Seconds + 0x5) % 60;
RTC_AlarmStructure.RTC_AlarmDateWeekDay = 0x31;
RTC_AlarmStructure.RTC_AlarmDateWeekDaySel = RTC_AlarmDateWeekDaySel_Date;
RTC_AlarmStructure.RTC_AlarmMask = RTC_AlarmMask_DateWeekDay | RTC_AlarmMask_Hours | RTC_AlarmMask_Minutes;
RTC_SetAlarm(RTC_Format_BIN, RTC_Alarm_A, &RTC_AlarmStructure);

//     " "
RTC_ITConfig(RTC_IT_ALRA, ENABLE);

//   " "
RTC_AlarmCmd(RTC_Alarm_A, ENABLE);

//   
RTC_ClearFlag(RTC_FLAG_ALRAF);

//   STANDBY
// !!!  PWR_EnterSTANDBYMode()    1.0.0.  !!!
//PWR_EnterSTANDBYMode();

//------------------------------------------------------------------------------
//      :
/* Set SLEEPDEEP bit of Cortex System Control Register */
  SCB->SCR |= SCB_SCR_SLEEPDEEP_Msk;

  /* Select STANDBY mode */
  PWR->CR &= ~PWR_CR_PDDS; //   ""      ""
  
  PWR->CR |= PWR_CR_CWUF;
  
  __WFI();
//------------------------------------------------------------------------------
  
}



void RTC_Alarm_IRQHandler (void)
{
//  
//  
SystemInit();
EXTI_ClearITPendingBit(EXTI_Line17);

}

//------------------------------------------------------------------------------
//---------------------------    ---------------------------
//---------------------------- support@promelec.ru -----------------------------
//------------------------------------------------------------------------------
